#include <bits/stdc++.h>
#define int long long
#define double long double

using namespace std;
const double eps = 1e-12;

int a[(int) 1e5], b[(int) 1e5];

double f(int x, int y){
    return ((double) x) / ((double) y);
}

double f(pair<int, int> p){
    return ((double) p.first) / ((double) p.second);
}
int n;
pair<int, pair<int, int>> pos(double d){
    int ans = 0;
    pair<int, int> mx = {0, 1};
    for(int i = 0; i < n; i++){
        if(f(a[0], b[i]) + eps > d) continue;

        int l = -1, r = n - 1, mid;
        while(r - l > 1){
            mid = (l + r + 1ll) / 2;
            if(f(a[mid], b[i]) >= d) r = mid;
            else l = mid;
        }
        ans += r + 1;
        if(f(a[r], b[i]) >= f(mx))
            mx = {a[r], b[i]};
    }
    return {ans, mx};
}

pair<int, int> ans(int p){
    double l = f(a[0], b[n - 1]), r = f(a[n - 1], b[0]) + eps, m;
//    cout << fixed << l << ' ' << r << '\n';
    while(r - l > eps){
        m = (l + r) / 2.0;
//        cout << fixed << m << '\n';
        auto t = pos(m);
        if(t.first >= p) r = m;
        else l = m;
    }
//    cout << fixed << r << '\n';
    auto t = pos(r);
    return t.second;
}

void solve() {
    int m;
    cin >> n >> m;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++)
        cin >> b[i];
    sort(a, a + n);
    sort(b, b + n);

    for(int i = 0, x; i < m; i++){
        cin >> x;
        pair<int, int> w = ans(x);
        int g = __gcd(w.first, w.second);
        cout << w.first / g << ' ' << w.second / g << '\n';
    }
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while(t--)
        solve();
    return 0;
}