#include <bits/stdc++.h>
#define int long long
#define double long double

using namespace std;
const double eps = 1e-8;

int a[(int) 1e5], b[(int) 1e5];

double f(int x, int y){
    return ((double) x) / ((double) y);
}

double f(pair<int, int> p){
    return ((double) p.first) / ((double) p.second);
}
int n;
pair<int, pair<int, int>> pos(double d){
    int ans = 0;
    pair<int, int> mx = {0, 1};
    for(int i = 0; i < n; i++){
        if(f(a[0], b[i]) > d) continue;

        int l = 0, r = n, mid;
        while(r - l > 1){
            mid = (l + r) / 2;
            if(f(a[mid], b[i]) > d - eps) r = mid;
            else l = mid;
        }
        ans += (l + 1);
        if(f(a[l], b[i]) > f(mx))
            mx = {a[l], b[i]};
    }
    return {ans, mx};
}

pair<int, int> ans(int p){
    double l = f(a[0], b[n - 1]), r = f(a[n - 1], b[0]) + eps, m;
//    cout << fixed << l << ' ' << r << '\n';
    while(r - l > eps){
        m = (l + r) / 2.0;
//        cout << fixed << m << '\n';
        auto t = pos(m);
        if(t.first <= p) l = m;
        else r = m;
    }
//    cout << fixed << l << '\n';
    auto t = pos(l);
    return t.second;
}

void solve() {
    cout.precision(10);
    int m;
    cin >> n >> m;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++)
        cin >> b[i];
    sort(a, a + n);
    sort(b, b + n);
//    for(int i = 0; i < n; i++)
//        cout << a[i] << ' ';
//    cout << '\n';
//    for(int i = 0; i < n; i++)
//        cout << b[i] << ' ';
//    cout << '\n';
//    cout << pos(0.5).first << ' ';
//    cout << pos(0.5).second.first << ' ' << pos(0.5).second.second << '\n';
    for(int i = 0, x; i < m; i++){
        cin >> x;
        pair<int, int> w = ans(x);
        int g = __gcd(w.first, w.second);
        cout << w.first / g << ' ' << w.second / g << '\n';
    }
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while(t--)
        solve();
    return 0;
}
